searchNodes=[{"doc":"Documentation for MafiaEngine.","ref":"MafiaEngine.html","title":"MafiaEngine","type":"module"},{"doc":"Hello world.Examplesiex&gt; MafiaEngine.hello() :world","ref":"MafiaEngine.html#hello/0","title":"MafiaEngine.hello/0","type":"function"},{"doc":"This module defines the type for accusations and functions to handle them.Examplesiex&gt; a = MafiaEngine.Accusations.new(2) %MafiaEngine.Accusations{ballots: %{}, required: 2} iex&gt; abed = MafiaEngine.Player.new(&quot;Abed&quot;) ...&gt; jeff = MafiaEngine.Player.new(&quot;Jeff&quot;) ...&gt; {:ok, a} = MafiaEngine.Accusations.accuse(a, abed, jeff) {:ok, %MafiaEngine.Accusations{ballots: %{&quot;Abed&quot; =&gt; &quot;Jeff&quot;}, required: 2}} iex&gt; a = MafiaEngine.Accusations.withdraw(a, &quot;Abed&quot;) %MafiaEngine.Accusations{ballots: %{}, required: 2} iex&gt; {:ok, a} = MafiaEngine.Accusations.accuse(a, jeff, abed) ...&gt; MafiaEngine.Accusations.accuse(a, abed, abed) {:accused, &quot;Abed&quot;, %MafiaEngine.Accusations{ ballots: %{&quot;Abed&quot; =&gt; &quot;Abed&quot;, &quot;Jeff&quot; =&gt; &quot;Abed&quot;}, required: 2 }}","ref":"MafiaEngine.Accusations.html","title":"MafiaEngine.Accusations","type":"module"},{"doc":"Adds the accusation from accuser to accused. It also checks if accused has the required accusations to be accused.Returns an error if either accuser or accused is not alive.Examplesiex&gt; a = MafiaEngine.Accusations.new(2) ...&gt; jeff = MafiaEngine.Player.new(&quot;Jeff&quot;) ...&gt; pierce = MafiaEngine.Player.new(&quot;Pierce&quot;) ...&gt; pierce = MafiaEngine.Player.kill(pierce) ...&gt; MafiaEngine.Accusations.accuse(a, pierce, jeff) {:error, :cannot_accuse_while_dead} iex&gt; MafiaEngine.Accusations.accuse(a, jeff, pierce) {:error, :cannot_accuse_dead_players}","ref":"MafiaEngine.Accusations.html#accuse/3","title":"MafiaEngine.Accusations.accuse/3","type":"function"},{"doc":"Creates a new accusations with required as the number of accusations required to cause a player to be accused.","ref":"MafiaEngine.Accusations.html#new/1","title":"MafiaEngine.Accusations.new/1","type":"function"},{"doc":"Removes the accusation from accuser if exists.","ref":"MafiaEngine.Accusations.html#withdraw/2","title":"MafiaEngine.Accusations.withdraw/2","type":"function"},{"doc":"","ref":"MafiaEngine.Accusations.html#t:t/0","title":"MafiaEngine.Accusations.t/0","type":"type"},{"doc":"This module defines the player type and functions to handle it.Examplesiex&gt; abed = MafiaEngine.Player.new(&quot;Abed&quot;) %MafiaEngine.Player{alive: true, name: &quot;Abed&quot;, role: :unknown} iex&gt; abed = MafiaEngine.Player.set_role(abed, :townie) %MafiaEngine.Player{alive: true, name: &quot;Abed&quot;, role: :townie} iex&gt; abed = MafiaEngine.Player.kill(abed) %MafiaEngine.Player{alive: false, name: &quot;Abed&quot;, role: :townie} iex&gt; abed.alive false","ref":"MafiaEngine.Player.html","title":"MafiaEngine.Player","type":"module"},{"doc":"Sets the player alive field to false.","ref":"MafiaEngine.Player.html#kill/1","title":"MafiaEngine.Player.kill/1","type":"function"},{"doc":"Creates a new player with the given name.","ref":"MafiaEngine.Player.html#new/1","title":"MafiaEngine.Player.new/1","type":"function"},{"doc":"Changes the player role the given role.","ref":"MafiaEngine.Player.html#set_role/2","title":"MafiaEngine.Player.set_role/2","type":"function"},{"doc":"Type that represents a player in the game.","ref":"MafiaEngine.Player.html#t:t/0","title":"MafiaEngine.Player.t/0","type":"type"},{"doc":"This module defines the type for a player list and functions to handle it.Examplesiex&gt; p = MafiaEngine.Players.new() [] iex&gt; {:ok, p} = MafiaEngine.Players.add(p, &quot;Abed&quot;) {:ok, [%MafiaEngine.Player{alive: true, name: &quot;Abed&quot;, role: :unknown}]} iex&gt; {:ok, p} = MafiaEngine.Players.add(p, &quot;Jeff&quot;) {:ok, [%MafiaEngine.Player{alive: true, name: &quot;Jeff&quot;, role: :unknown}, %MafiaEngine.Player{alive: true, name: &quot;Abed&quot;, role: :unknown}] } iex&gt; MafiaEngine.Players.names(p) [&quot;Jeff&quot;, &quot;Abed&quot;] iex&gt; p = MafiaEngine.Players.remove(p, &quot;Abed&quot;) [%MafiaEngine.Player{alive: true, name: &quot;Jeff&quot;, role: :unknown}] iex&gt; MafiaEngine.Players.set_roles(p, [:townie]) [%MafiaEngine.Player{alive: true, name: &quot;Jeff&quot;, role: :townie}]","ref":"MafiaEngine.Players.html","title":"MafiaEngine.Players","type":"module"},{"doc":"Adds a new player with the given name unless name is taken.Examplesiex&gt; p = MafiaEngine.Players.new() [] iex&gt; {:ok, p} = MafiaEngine.Players.add(p, &quot;Abed&quot;) {:ok, [%MafiaEngine.Player{alive: true, name: &quot;Abed&quot;, role: :unknown}]} iex&gt; MafiaEngine.Players.add(p, &quot;Abed&quot;) {:error, :name_already_taken}","ref":"MafiaEngine.Players.html#add/2","title":"MafiaEngine.Players.add/2","type":"function"},{"doc":"Returns the player with the given name from the list.If the player does not exist it returns none instead.","ref":"MafiaEngine.Players.html#get/2","title":"MafiaEngine.Players.get/2","type":"function"},{"doc":"Sets the player with the given name alive field to false.","ref":"MafiaEngine.Players.html#kill/2","title":"MafiaEngine.Players.kill/2","type":"function"},{"doc":"Returns a list with the player names.","ref":"MafiaEngine.Players.html#names/1","title":"MafiaEngine.Players.names/1","type":"function"},{"doc":"Creates a new player list.","ref":"MafiaEngine.Players.html#new/0","title":"MafiaEngine.Players.new/0","type":"function"},{"doc":"Removes the player with the given name from the list if exists.","ref":"MafiaEngine.Players.html#remove/2","title":"MafiaEngine.Players.remove/2","type":"function"},{"doc":"Sets the player with the given name role to role.","ref":"MafiaEngine.Players.html#set_role/3","title":"MafiaEngine.Players.set_role/3","type":"function"},{"doc":"Gives a role from role_list at random to each player.The role_list should have the same lenght as the player list.","ref":"MafiaEngine.Players.html#set_roles/2","title":"MafiaEngine.Players.set_roles/2","type":"function"},{"doc":"","ref":"MafiaEngine.Players.html#t:t/0","title":"MafiaEngine.Players.t/0","type":"type"},{"doc":"This module defines the type for role.","ref":"MafiaEngine.Role.html","title":"MafiaEngine.Role","type":"module"},{"doc":"The possible outcomes resulting of role interactions during the night phase.","ref":"MafiaEngine.Role.html#t:outcome/0","title":"MafiaEngine.Role.outcome/0","type":"type"},{"doc":"The possible roles aplayer can have.","ref":"MafiaEngine.Role.html#t:t/0","title":"MafiaEngine.Role.t/0","type":"type"},{"doc":"This module defines the type for votes and functions to handle them.Examplesiex&gt; v = MafiaEngine.Votes.new(&quot;Annie&quot;) ...&gt; jeff = MafiaEngine.Player.new(&quot;Jeff&quot;) ...&gt; abed = MafiaEngine.Player.new(&quot;Abed&quot;) ...&gt; {:ok, v} = MafiaEngine.Votes.vote(v, :guilty, jeff) ...&gt; {:ok, v} = MafiaEngine.Votes.vote(v, :innocent, abed) ...&gt; v.guilty #MapSet&lt;[&quot;Jeff&quot;]&gt; iex&gt; v.innocent #MapSet&lt;[&quot;Abed&quot;]&gt; iex&gt; MafiaEngine.Votes.result(v) :innocent iex&gt; v = MafiaEngine.Votes.remove_vote(v, &quot;Abed&quot;) ...&gt; v.innocent #MapSet&lt;[]&gt; iex&gt; MafiaEngine.Votes.result(v) :guilty","ref":"MafiaEngine.Votes.html","title":"MafiaEngine.Votes","type":"module"},{"doc":"Creates votes data type with accused as the accused.","ref":"MafiaEngine.Votes.html#new/1","title":"MafiaEngine.Votes.new/1","type":"function"},{"doc":"Removes the vote from the given voter if exists.","ref":"MafiaEngine.Votes.html#remove_vote/2","title":"MafiaEngine.Votes.remove_vote/2","type":"function"},{"doc":"Returns :guilty if there is more guilty votes and :innocent otherwise.","ref":"MafiaEngine.Votes.html#result/1","title":"MafiaEngine.Votes.result/1","type":"function"},{"doc":"Adds the vote of voter.Returns an error if the voter is the accused or is not alive.##Examplesiex&gt; v = MafiaEngine.Votes.new(&quot;Annie&quot;) ...&gt; annie = MafiaEngine.Player.new(&quot;Annie&quot;) ...&gt; pierce = MafiaEngine.Player.new(&quot;Pierce&quot;) ...&gt; pierce = MafiaEngine.Player.kill(pierce) ...&gt; MafiaEngine.Votes.vote(v, :guilty, pierce) {:error, :cannot_vote_while_dead} iex&gt; MafiaEngine.Votes.vote(v, :innocent, annie) {:error, :accused_player_cannot_vote}","ref":"MafiaEngine.Votes.html#vote/3","title":"MafiaEngine.Votes.vote/3","type":"function"},{"doc":"","ref":"MafiaEngine.Votes.html#t:t/0","title":"MafiaEngine.Votes.t/0","type":"type"},{"doc":"","ref":"MafiaEngine.Votes.html#t:vote/0","title":"MafiaEngine.Votes.vote/0","type":"type"}]